var info;
var lightboxes; 
var activeLightbox;
var lightboxTitle = '';
var selectedLightboxPhotos = new Hash();
var activeLightboxId;
var imageTemplateHTML = '<div id="lightbox-photo-<!-- photo_id -->" class="floated-image" onmouseover="$(\'select-<!-- photo_id -->\').show()" onmouseout="$(\'select-<!-- photo_id -->\').style.display = selectedLightboxPhotos[<!-- photo_id -->] ? \'block\' : \'none\'" > <center id="lightbox-thumb-<!-- photo_id -->"> <div style="color: #e0e0e0; font-size: 10px; padding: 20px; text-align: center; width: 100%; vertical-align: center;">loading...</div> </center> <center> <div id="select-<!-- photo_id -->" class="photo-select-link" style="display: none; cursor: default"><input id="lightbox-photo-checkbox-<!-- photo_id -->" type="checkbox" onclick="togglePhotoSelection(<!-- photo_id -->)"></div> </center> </div> ';
var lockChangeLightboxDialog = false;


function $t(index) {
	return info[index];
}

function updateLightboxNameDisplay(newName) {
	if (!newName) {
		newName = $('lightbox-new-name-input').value;
	}

	$('rename-message').innerHTML = '';
	
	newName = newName.replace(/^\s+/, '');
	newName = newName.replace(/\s+/g, ' ');

	$('lightbox-new-name-input').value = newName;
	$('lightbox-title').innerHTML = newName;
}

function resetLightboxNameDisplay() {
	$('lightbox-title').style.color = '#383838';
	$('lightbox-title').innerHTML = lightboxTitle;
}

function showLightboxDialog(action) {
	hideLightboxDialogs();
	$(action + '-lightbox-link').className = 'selected-lightbox-link';
	$(action + '-lightbox-dialog').show();
	$(action + '-lightbox-dialog').style.zIndex = parseInt(new Date().getTime()/1000); 	// to appease IE6
	$('lightbox-input-bar').show();

	if (action == 'rename') {
		$('lightbox-title').style.color = '#a0a0a0';
		$('lightbox-new-name-input').focus();
	} else {
		$('lightbox-title').style.color = '#383838';
	}
}

function hideLightboxDialogs() {
	$('lightbox-input-bar').hide();
	new Array('create','rename', 'delete').each( 
		function(action) {
			$(action + '-lightbox-dialog').hide();
			$(action + '-lightbox-link').className = 'inactive-lightbox-link';
		}
	);
}

function renameLightbox(lightboxId, newName) {

	newName = newName.replace(/\s+$/, '');
	if (lightboxes[lightboxId]['title'] != newName) {	
		new Ajax.Request( './image.php?action=rename_lightbox', {
			parameters: {
				lightbox_id: lightboxId,
				new_name: newName
			},
			onFailure: function(transport) {
				alert( $t('LB_TECHNICAL_ERROR_RENAMING'));
				$('lightbox-title').innerHTML = lightboxes[lightboxId]['title'];
			},
			onSuccess: function(transport) {
				lightboxTitle = newName;
				lightboxes[lightboxId]['title'] = newName;
				activeLightbox['title'] = newName;
				refreshLightboxListings();
			}
		} );
	}
	$('lightbox-title').style.color = '#383838';
	hideLightboxDialogs();
}

function createLightbox(lightboxName,photoId) {

	$('lightbox-count').innerHTML = '0';
	$('lightbox-title').innerHTML = lightboxName;
	$('lightbox-title').style.color = '#a0a0a0';

	new Ajax.Request( './image.php?action=create_lightbox', {
		parameters: {
			lightbox_name: lightboxName
		},
		onSuccess: function(transport) {
		    $('create-lightbox-dialog').hide();
			window.location.reload();//refresh
		},
		onFailure: function(transport) {
			alert( $t('LB_TECHNICAL_ERROR_CREATING') );
		}
	} );
}

function deleteLightbox(lightboxId) {
	if (selectedLightboxPhotos.keys().length) {
		var proceed = confirm( $t('LB_SELECTED_PHOTOS_CONFIRM_DELETE') );
		if (!proceed) {
			hideLightboxDialogs();
			return;
		}
	}
	new Ajax.Request( './image.php?action=delete_lightbox', {
		parameters: {
			lightbox_id: lightboxId
		},
		onFailure: function(transport) { 
			alert( $t('LB_TECHNICAL_ERROR_DELETING') );
		},
		onSuccess: function(transport) {
			//lightboxes.remove(lightboxId);
			$('delete-lightbox-dialog').hide();
			alert( $t('LB_LIGHTBOX_DELETED') );
			window.location.reload();//refresh
		}
	} );

}

function togglePhotoSelection(photoId) {
	if (selectedLightboxPhotos[photoId]) {
		$H(selectedLightboxPhotos).remove(photoId);
		$('lightbox-photo-' + photoId).removeClassName('selected-lightbox-photo');
		$('lightbox-photo-checkbox-' + photoId).checked = false;
		
	} else {
		selectedLightboxPhotos[photoId] = true;
		$('lightbox-photo-' + photoId).addClassName('selected-lightbox-photo');
		$('lightbox-photo-checkbox-' + photoId).checked = true;
	}
}


function redirectLightboxPage(lightboxId) {
	location.href = './image.php?action=list_lightbox&id=' + lightboxId;
}

function refreshLightboxListings() {//*

	if ($('add-image-to-lightbox-listing')) 
		$('add-image-to-lightbox-listing').innerHTML = generateLightboxListing(lightboxes, 'addImageToLightbox');

	if ($('change-lightbox-listing'))
		$('change-lightbox-listing').innerHTML = generateLightboxListing(lightboxes,  'redirectLightboxPage', true);		

	if ($('copy-lightbox-listing'))
		$('copy-lightbox-listing').innerHTML = generateLightboxListing(lightboxes, 'copySelectedPhotos', true);

	if ($('move-lightbox-listing'))
		$('move-lightbox-listing').innerHTML = generateLightboxListing(lightboxes, 'moveSelectedPhotos', true);

}

function removeSelectedPhotos(lightboxId, forMove) {
	var selectedPhotoCount = selectedLightboxPhotos.keys().length;
	if (selectedPhotoCount == 0) {
		alert( $t('LB_SELECT_TO_REMOVE') );
		return;
	}

	if (!forMove) {
		var confirmationMessage;
		
		if (selectedPhotoCount == 1) 
			confirmationMessage = $t('LB_REMOVE_CONFIRM_SINGULAR');
		else 
			confirmationMessage = $t('LB_REMOVE_CONFIRM_PLURAL');
		if (!confirm(confirmationMessage)) {
			return;
		}
	}

	selectedLightboxPhotos.keys().each( function(photoId) {
		$('lightbox-photo-' + photoId).addClassName('semi-transparent');
	} );

	var photoIdsList = selectedLightboxPhotos.keys().join(',');

	new Ajax.Request( './image.php?action=remove_from_lightbox', {
		parameters: {
			photo_ids: photoIdsList,
			lightbox_id: lightboxId
		},
		onFailure: function(transport) {
			alert( $t('LB_TECHNICAL_ERROR_REMOVING') );
		},
		onSuccess: function(transport) {
			var removalCount = 0;
			selectedLightboxPhotos.keys().each( function(photoId) {
				selectedLightboxPhotos.remove(photoId);
				$('lightbox-photo-' + photoId).hide();
				removalCount++;
			} );
			activeLightbox['count'] -= removalCount;
			$('lightbox-count').innerHTML = parseInt($('lightbox-count').innerHTML) - removalCount;
		}
	} );
}

function copySelectedPhotos(lightboxId, forMove) {
	var selectedPhotoCount = selectedLightboxPhotos.keys().length;
	hideLightboxDropdowns();
	var photoIdsList = selectedLightboxPhotos.keys().join(',');
	new Ajax.Request( './image.php?action=copy_to_lightbox', {
		parameters: {
			photo_ids: photoIdsList,
			lightbox_id: lightboxId
		},
		onFailure: function(transport) {
			alert( $t('LB_TECHNICAL_ERROR_COPYING') );
		},
		onSuccess: function(transport) {
			if (forMove) {
				removeSelectedPhotos(activeLightboxId, true);
			} else {
				var confirmationMessage;
				if (selectedPhotoCount == 1) 
					confirmationMessage = $t('LB_COPY_SUCCESS_SINGULAR');
				else 
					confirmationMessage = $t('LB_COPY_SUCCESS_PLURAL');

				alert(confirmationMessage);

				selectedLightboxPhotos.keys().each( function(photoId) {
					togglePhotoSelection(photoId);
					$('select-' + photoId).style.opacity = 0;
				} );
			}
		}
	} );
}

function moveSelectedPhotos(lightboxId) {
	copySelectedPhotos(lightboxId, true);
}

function addImageToLightbox(lightboxId) {
	var photoId = selectedPhotoId;
	new Ajax.Request( './image.php?action=copy_to_lightbox', {
		parameters: {
			photo_ids: photoId,
			lightbox_id: lightboxId
		},
		onSuccess: function(transport) {

		},
		onFailure: function(transport) {
			alert( $t('LB_TECHNICAL_ERROR_ADDING') );
		}
	} );
}

function generateLightboxListing(lightboxes, onclickAction, dontShowActive) {
	var output = '';
	var t = new Template('<div onmouseover="this.style.backgroundColor = \'#f0f4ff\'" onmouseout="this.style.backgroundColor = \'white\'" onclick="' + onclickAction + '(#{id})" class="lightbox-dialog-link">#{title}</div>');
	lightboxes.keys().sort( function(a, b) {
		return lightboxes[b]['last_modified'] - lightboxes[a]['last_modified'];
	} )
	.each( function(lightboxId) {
		if (!(dontShowActive && lightboxId == activeLightboxId)) {
			output += t.evaluate(lightboxes[lightboxId]);
		} 
	} );
	return output;
}

function hideLightboxDropdowns() {
    if($('add-to-lightbox-dialog'))
    $('add-to-lightbox-dialog').hide();
    if($('change-lightbox-dialog'))
	$('change-lightbox-dialog').hide();
	if($('copy-lightbox-dialog'))
	$('copy-lightbox-dialog').hide();
	if($('move-lightbox-dialog'))
	$('move-lightbox-dialog').hide();

}

function showCopyDialog() {
	hideLightboxDropdowns();
	if (lightboxes.keys().length <= 1) {
		alert( $t('LB_NO_OTHER_LIGHTBOXES_COPY') );
		return;
	}
	var selectedPhotoCount = selectedLightboxPhotos.keys().length;
	if (selectedPhotoCount < 1) {
		alert( $t('LB_SELECT_PHOTOS_COPY') );
		return;
	} else {
		$('copy-lightbox-dialog').show();
	}
}

function showMoveDialog() {
	hideLightboxDropdowns();
	if (lightboxes.keys().length <= 1) {
		alert( $t('LB_NO_OTHER_LIGHTBOXES_MOVE') );
		return;
	}

	var selectedPhotoCount = selectedLightboxPhotos.keys().length;
	if (selectedPhotoCount < 1) {
		alert( $t('LB_SELECT_PHOTOS_MOVE') );
		return;
	} else {
		$('move-lightbox-dialog').show();
	}
}

function showChangeLightboxDialog() {

	if (lightboxes.keys().length > 1) {
		$('change-lightbox-dialog').show();
	}
}

function toggleChangeLightboxDialog() {
	if ($('change-lightbox-dialog').visible) {
		if (lockChangeLightboxDialog) {
			lockChangeLightboxDialog = false;
			$('change-lightbox-dialog').hide();
		} else {
			lockChangeLightboxDialog = true;
		}
	} else {
		lockChangeLightboxDialog = true;
	}
}

function hideChangeLightboxDialog() {

	if (lockChangeLightboxDialog) {
		return;
	} else {
		$('change-lightbox-dialog').hide();
		lockChangeLightboxDialog = false;
	}
}