# --------------------------------------------------------
# IMS MySQL-Dump - DON'T EDIT THIS FILE!!!!!!!!!!!!!!!
# --------------------------------------------------------

# CREATE DATABASE IF NOT EXISTS `imagestock` CHARACTER SET utf8;


#
# Table structure for table ims_categories
#

DROP TABLE IF EXISTS `ims_categories`;
CREATE TABLE `ims_categories` (
  `cat_id` int(10) unsigned NOT NULL auto_increment,
  `cat_name` varchar(255) NOT NULL default '',
  `cat_description` text NOT NULL,
  `cat_parent_id` int(10) unsigned NOT NULL default '0',
  `cat_order` int(10) unsigned NOT NULL default '0',
  PRIMARY KEY  (`cat_id`)
) ENGINE=MyISAM DEFAULT CHARSET=utf8;

INSERT INTO ims_categories VALUES ('1', 'root', 'root category', '0', 0);

DROP TABLE IF EXISTS `ims_images`;
CREATE TABLE `ims_images` (
  `image_id` int(10) unsigned NOT NULL auto_increment,
  `cat_id` int(10) unsigned NOT NULL default '0',
  `user_id` int(10) unsigned NOT NULL default '0',
  `image_name` varchar(255) NOT NULL default '',
  `image_description` text NOT NULL,
  `image_keyword_ids` text NOT NULL,
  `image_create_time` int(11) unsigned NOT NULL default '0',
  `image_edit_time` int(11) unsigned NOT NULL default '0',
  `image_active` tinyint(1) NOT NULL default '1',
  `image_filename` varchar(255) NOT NULL default '',
  `image_size` int(10) unsigned NOT NULL default '0',
  `image_width` int(10) unsigned NOT NULL default '0',
  `image_height` int(10) unsigned NOT NULL default '0',
  `image_download_url` varchar(255) NOT NULL default '',
  `image_downloads` int(10) unsigned NOT NULL default '0',
  `image_votes` int(10) unsigned NOT NULL default '0',
  `image_rating` decimal(4,2) unsigned NOT NULL default '0.00',
  `image_hits` int(10) unsigned NOT NULL default '0',
  PRIMARY KEY  (`image_id`)
) ENGINE=MyISAM DEFAULT CHARSET=utf8;


DROP TABLE IF EXISTS `ims_keywords`;
CREATE TABLE `ims_keywords` (
  `keyword_id` int(10) unsigned NOT NULL auto_increment,
  `keyword_text` varchar(50) NOT NULL default '',
  PRIMARY KEY  (keyword_id)
) ENGINE=MyISAM DEFAULT CHARSET=utf8;


DROP TABLE IF EXISTS `ims_comments`;
CREATE TABLE `ims_comments` (
  `comment_id` int(10) unsigned NOT NULL auto_increment,
  `image_id` int(10) unsigned NOT NULL default '0',
  `user_id` int(10) unsigned NOT NULL default '0',
  `comment_headline` varchar(255) NOT NULL default '',
  `comment_text` text NOT NULL,
  `comment_ip` varchar(20) NOT NULL default '',
  `comment_date` int(11) unsigned NOT NULL default '0',
  PRIMARY KEY  (`comment_id`)
) ENGINE=MyISAM DEFAULT CHARSET=utf8;


DROP TABLE IF EXISTS `ims_lightboxes`;
CREATE TABLE `ims_lightboxes` (
  `lightbox_id` int(10) unsigned NOT NULL auto_increment,
  `user_id` int(10) unsigned NOT NULL default '0',
  `lightbox_name` varchar(255) NOT NULL default '',
  `lightbox_public` tinyint(1) NOT NULL default '1',
  `lightbox_lastvisit` int(11) unsigned NOT NULL default '0',
  PRIMARY KEY  (`lightbox_id`)
) ENGINE=MyISAM DEFAULT CHARSET=utf8;


DROP TABLE IF EXISTS `ims_lightboxmatch`;
CREATE TABLE `ims_lightboxmatch` (
  `lightbox_id` int(10) unsigned NOT NULL,
  `image_id` int(10) unsigned NOT NULL,
  PRIMARY KEY  (`lightbox_id`,`image_id`)
) ENGINE=MyISAM DEFAULT CHARSET=utf8;


DROP TABLE IF EXISTS `ims_settings`;
CREATE TABLE `ims_settings` (
  `setting_name` varchar(255) NOT NULL default '',
  `setting_value` mediumtext NOT NULL,
  PRIMARY KEY  (setting_name)
) ENGINE=MyISAM DEFAULT CHARSET=utf8;

INSERT INTO ims_settings VALUES ('smtp_server', '');
INSERT INTO ims_settings VALUES ('smtp_port', '');
INSERT INTO ims_settings VALUES ('smtp_username', '');
INSERT INTO ims_settings VALUES ('smtp_password', '');


DROP TABLE IF EXISTS `ims_users`;
CREATE TABLE `ims_users` (
  `user_id` int(10) unsigned NOT NULL auto_increment,
  `user_name` varchar(255) NOT NULL default '',
  `user_password` varchar(255) NOT NULL default '',
  `user_email` varchar(255) NOT NULL default '',
  `user_showemail` tinyint(1) NOT NULL default '1',
  `user_allowemails` tinyint(1) NOT NULL default '1',
  `user_visible` tinyint(1) NOT NULL default '1',
  `user_joindate` int(11) unsigned NOT NULL default '0',
  `user_active` tinyint(1) NOT NULL default '1',
  `user_lastvisit` int(11) unsigned NOT NULL default '0',
  `user_comments` text NOT NULL,
  `user_homepage` varchar(255) NOT NULL default '',
  `user_msn` varchar(50) NOT NULL default '',
  `user_icq` varchar(20) NOT NULL default '',
  `user_address` varchar(255) NOT NULL default '',
  `user_role` int(10) unsigned NOT NULL default '0',
  PRIMARY KEY  (`user_id`)
) ENGINE=MyISAM DEFAULT CHARSET=utf8;


DROP TABLE IF EXISTS `ims_roles`;
CREATE TABLE `ims_roles` (
  `role_id` int(10) unsigned NOT NULL,
  `role_name` varchar(255) NOT NULL default '',
  `role_permissions` text NOT NULL,
  PRIMARY KEY  (`role_id`)
) ENGINE=MyISAM DEFAULT CHARSET=utf8;

INSERT INTO ims_roles VALUES ('1', 'registered', 'search,view,download,rate,post,lightbox');
INSERT INTO ims_roles VALUES ('2', 'admin', 'search,view,download,rate,post,lightbox,admin');
